library Python4mIRC;

{%TogetherDiagram 'ModelSupport_Python4mIRC\default.txaPackage'}

uses
  SysUtils,
  Classes,
  windows,
  Messages,
  PsAPI,
  TlHelp32,
  mIRCCLass in 'mIRCCLass.pas';

type
    TLoadInfo = record
        mVersion : DWORD;
        mHwnd    : HWND;
        mKeep    : Boolean;
    end;
    PLoadInfo = ^TLoadInfo;


var
    Debug: Boolean = False;


{$R *.res}

{ Useful stuff! }


function Evaluate(H:HWnd; S:String):String;
var FMData:PChar; FileMap: THandle;
begin
    result := '';
    FileMap := CreateFileMapping(INVALID_HANDLE_VALUE,Nil,PAGE_READWRITE,0,4096,'mIRC');
    FMData := MapViewOfFile(FileMap,FILE_MAP_ALL_ACCESS,0,0,0);
    StrPCopy(FMData, S);
    SendMessage(H, WM_USER +201, 1, 0);
    CloseHandle(FileMap);
    result := FMData;
end;

procedure Command(H:HWnd; S:String);
var FMData:PChar; FileMap: THandle;
begin
    FileMap := CreateFileMapping(INVALID_HANDLE_VALUE,Nil,PAGE_READWRITE,0,4096,'mIRC');
    FMData := MapViewOfFile(FileMap,FILE_MAP_ALL_ACCESS,0,0,0);
    StrPCopy(FMData, S);
    SendMessage(H, WM_USER +200, 1, 0);
    CloseHandle(FileMap);
end;




//  THE FOLLOWING PART IS NOT MY WORK
//  GOT IT SOMEWHERE, AGES AGO, BUT CAN'T REMEMBER WHERE!
//

// portions by Project Jedi www.delphi-jedi.org/
const
  RsSystemIdleProcess = 'System Idle Process';
  RsSystemProcess = 'System Process';

function IsWinXP: Boolean;
begin
  Result := (Win32Platform = VER_PLATFORM_WIN32_NT) and
    (Win32MajorVersion = 5) and (Win32MinorVersion = 1);
end;

function IsWin2k: Boolean;
begin
  Result := (Win32MajorVersion >= 5) and
    (Win32Platform = VER_PLATFORM_WIN32_NT);
end;

function IsWinNT4: Boolean;
begin
  Result := Win32Platform = VER_PLATFORM_WIN32_NT;
  Result := Result and (Win32MajorVersion = 4);
end;

function IsWin3X: Boolean;
begin
  Result := Win32Platform = VER_PLATFORM_WIN32_NT;
  Result := Result and (Win32MajorVersion = 3) and
    ((Win32MinorVersion = 1) or (Win32MinorVersion = 5) or
    (Win32MinorVersion = 51));
end;

function RunningProcessesList(const List: TStrings; FullPath: Boolean): Boolean;

  function ProcessFileName(PID: DWORD): string;
  var
    Handle: THandle;
  begin
    Result := '';
    Handle := OpenProcess(PROCESS_QUERY_INFORMATION or PROCESS_VM_READ, False, PID);
    if Handle <> 0 then
      try
        SetLength(Result, MAX_PATH);
        if FullPath then
        begin
          if GetModuleFileNameEx(Handle, 0, PChar(Result), MAX_PATH) > 0 then
            SetLength(Result, StrLen(PChar(Result)))
          else
            Result := '';
        end
        else
        begin
          if GetModuleBaseNameA(Handle, 0, PChar(Result), MAX_PATH) > 0 then
            SetLength(Result, StrLen(PChar(Result)))
          else
            Result := '';
        end;
      finally
        CloseHandle(Handle);
      end;
  end;

  function BuildListTH: Boolean;
  var
    SnapProcHandle: THandle;
    ProcEntry: TProcessEntry32;
    NextProc: Boolean;
    FileName: string;
  begin
    SnapProcHandle := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
    Result := (SnapProcHandle <> INVALID_HANDLE_VALUE);
    if Result then
      try
        ProcEntry.dwSize := SizeOf(ProcEntry);
        NextProc := Process32First(SnapProcHandle, ProcEntry);
        while NextProc do
        begin
          if ProcEntry.th32ProcessID = 0 then
          begin
            // PID 0 is always the "System Idle Process" but this name cannot be
            // retrieved from the system and has to be fabricated.
            FileName := RsSystemIdleProcess;
          end
          else
          begin
            if IsWin2k or IsWinXP then
            begin
              FileName := ProcessFileName(ProcEntry.th32ProcessID);
              if FileName = '' then
                FileName := ProcEntry.szExeFile;
            end
            else
            begin
              FileName := ProcEntry.szExeFile;
              if not FullPath then
                FileName := ExtractFileName(FileName);
            end;
          end;
          List.AddObject(FileName, Pointer(ProcEntry.th32ProcessID));
          NextProc := Process32Next(SnapProcHandle, ProcEntry);
        end;
      finally
        CloseHandle(SnapProcHandle);
      end;
  end;

  function BuildListPS: Boolean;
  var
    PIDs: array [0..1024] of DWORD;
    Needed: DWORD;
    I: Integer;
    FileName: string;
  begin
    Result := EnumProcesses(@PIDs, SizeOf(PIDs), Needed);
    if Result then
    begin
      for I := 0 to (Needed div SizeOf(DWORD)) - 1 do
      begin
        case PIDs[I] of
          0:
            // PID 0 is always the "System Idle Process" but this name cannot be
            // retrieved from the system and has to be fabricated.
            FileName := RsSystemIdleProcess;
          2:
            // On NT 4 PID 2 is the "System Process" but this name cannot be
            // retrieved from the system and has to be fabricated.
            if IsWinNT4 then
              FileName := RsSystemProcess
            else
              FileName := ProcessFileName(PIDs[I]);
            8:
            // On Win2K PID 8 is the "System Process" but this name cannot be
            // retrieved from the system and has to be fabricated.
            if IsWin2k or IsWinXP then
              FileName := RsSystemProcess
            else
              FileName := ProcessFileName(PIDs[I]);
            else
              FileName := ProcessFileName(PIDs[I]);
        end;
        if FileName <> '' then
          List.AddObject(FileName, Pointer(PIDs[I]));
      end;
    end;
  end;
begin
  if IsWin3X or IsWinNT4 then
    Result := BuildListPS
  else
    Result := BuildListTH;
end;

function GetProcessNameFromWnd(Wnd: HWND): string;
var
  List: TStringList;
  PID: DWORD;
  I: Integer;
begin
  Result := '';
  if IsWindow(Wnd) then
  begin
    PID := INVALID_HANDLE_VALUE;
    GetWindowThreadProcessId(Wnd, @PID);
    List := TStringList.Create;
    try
      if RunningProcessesList(List, True) then
      begin
        I := List.IndexOfObject(Pointer(PID));
        if I > -1 then
          Result := List[I];
      end;
    finally
      List.Free;
    end;
  end;
end;
{ END OF CODE BY ANONYMOUS! }




{ Python Wrappers }
function PyRun_SimpleFileEx(FHandle: DWord; const filename: PChar; closeit: integer): Integer;
cdecl; external 'python25.dll' name 'PyRun_SimpleFileEx';

function PyRun_SimpleString(const command: PChar): Integer; cdecl; external 'python25.dll'
name 'PyRun_SimpleString';
function PyString(command: String): Integer;
begin
    Result := PyRun_SimpleString(PChar(command+#10));
end;

procedure Py_Initialize(); stdcall; external 'python25.dll' name 'Py_Initialize';
procedure Py_Finalize(); stdcall; external 'python25.dll' name 'Py_Finalize';


{ Exported DLL Functions }

function Python(mWnd, aWnd: HWND; Data, Params: PChar; Show, NoPause: boolean):integer; stdcall;
begin                      
  StrCopy(Data, PChar(inttostr(PyString(Data)+1)));
  Result := 3;
end;



function PythonFile(mWnd, aWnd: HWND; Data, Params: PChar; Show, NoPause: boolean):integer; stdcall;
var handle: integer;
begin
  handle := FileOpen(Data, fmOpenRead or fmShareDenyNone);
  if handle > 0 then
    StrCopy(Data, PChar(inttostr(PyRun_SimpleFileEx(handle, Data, 1))))
  else
    StrCopy(Data, PChar('-2 Unable to open file.'));
  Result := 3;
end;   { Undocumented piece of shit! DO NOT USE! NEVER EVER! DOESNT EVEN TRY TO WORK! }




function UnloadDll(mTimeout:integer): integer; stdcall;
begin                
    if mTimeout = 0 then begin
        Result := 1;
        Py_Finalize();
    end
    else Result := 0;
end;

procedure LoadDll(LI:PLoadInfo); stdcall;
var path, module: string;
    fnstdout, fnstderr: string;
const
    imports: array[0..5] of string = ('sys', 'os', 'mmap', 'win32api', 'traceback', 'exceptions');
begin
    LI.mKeep := True;
    Py_Initialize();
    Command(LI.mHwnd, '//echo -s Python initialized!');
    path := stringreplace(ExtractFilePath(GetProcessNameFromWnd(LI.mHwnd)),#92,#92#92, [rfReplaceAll]);
    fnstdout := path+'pystdout';
    fnstderr := path+'pystderr';

    {  DEBUG STUFF! }
    PyString('import sys');
    if PyString('nstdout = file("'+fnstdout+'", "w")'#10) = -1 then begin
        Command(LI.mHwnd, '//echo -s Unable to open '+fnstdout+' for logging.');
        exit;
    end
    else if debug then
         Command(LI.mHwnd, '//echo -s Opened '+fnstdout+' for error logging');
    if PyString('nstderr = file("'+fnstderr+'", "w")'#10) = -1 then
        Command(LI.mHwnd, '//echo -s Unable to open '+fnstderr+' for logging.')
    else begin
        if debug then begin
            Command(LI.mHwnd, '//echo -s Opened '+fnstderr+' for error logging');
        end;
        PyString('sys.stdout = nstdout'#10+
                 'sys.stderr = nstderr'#10);
    end;

    
    for module in imports do
        if PyString('import '+module+#10) = -1 then begin
            Command(LI.mHwnd, '//echo -s Unable to import '+module);
            exit;
        end;
    PyString('mHwnd = '+inttostr(LI.mHwnd));
    PyString(mIRCClass.mIRCObject);
    PyString('mIRC = mIRCObject(mHwnd)');
    PyString(mIRCClass.fileparser);
    PyString('sys.stdout = mIRC.stdout');
    PyString('sys.stderr = mIRC.stderr');
end;


exports
  Python,
  PythonFile,
  LoadDll,
  UnloadDll;


begin
end.
